Title: WP_REST_Users_Controller::register_routes
Published: December 6, 2016
Last modified: April 28, 2025

---

# WP_REST_Users_Controller::register_routes()

## In this article

 * [Description](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#description)
    - [See also](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#see-also)
 * [Source](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#source)
 * [Related](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#related)
 * [Changelog](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#changelog)

[ Back to top](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#wp--skip-link--target)

Registers the routes for users.

## 󠀁[Description](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#description)󠁿

### 󠀁[See also](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#see-also)󠁿

 * [register_rest_route()](https://developer.wordpress.org/reference/functions/register_rest_route/)

## 󠀁[Source](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#source)󠁿

    ```php
    public function register_routes() {

    	register_rest_route(
    		$this->namespace,
    		'/' . $this->rest_base,
    		array(
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'callback'            => array( $this, 'get_items' ),
    				'permission_callback' => array( $this, 'get_items_permissions_check' ),
    				'args'                => $this->get_collection_params(),
    			),
    			array(
    				'methods'             => WP_REST_Server::CREATABLE,
    				'callback'            => array( $this, 'create_item' ),
    				'permission_callback' => array( $this, 'create_item_permissions_check' ),
    				'args'                => $this->get_endpoint_args_for_item_schema( WP_REST_Server::CREATABLE ),
    			),
    			'allow_batch' => $this->allow_batch,
    			'schema'      => array( $this, 'get_public_item_schema' ),
    		)
    	);

    	register_rest_route(
    		$this->namespace,
    		'/' . $this->rest_base . '/(?P<id>[\d]+)',
    		array(
    			'args'        => array(
    				'id' => array(
    					'description' => __( 'Unique identifier for the user.' ),
    					'type'        => 'integer',
    				),
    			),
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'callback'            => array( $this, 'get_item' ),
    				'permission_callback' => array( $this, 'get_item_permissions_check' ),
    				'args'                => array(
    					'context' => $this->get_context_param( array( 'default' => 'view' ) ),
    				),
    			),
    			array(
    				'methods'             => WP_REST_Server::EDITABLE,
    				'callback'            => array( $this, 'update_item' ),
    				'permission_callback' => array( $this, 'update_item_permissions_check' ),
    				'args'                => $this->get_endpoint_args_for_item_schema( WP_REST_Server::EDITABLE ),
    			),
    			array(
    				'methods'             => WP_REST_Server::DELETABLE,
    				'callback'            => array( $this, 'delete_item' ),
    				'permission_callback' => array( $this, 'delete_item_permissions_check' ),
    				'args'                => array(
    					'force'    => array(
    						'type'        => 'boolean',
    						'default'     => false,
    						'description' => __( 'Required to be true, as users do not support trashing.' ),
    					),
    					'reassign' => array(
    						'type'              => 'integer',
    						'description'       => __( 'Reassign the deleted user\'s posts and links to this user ID.' ),
    						'required'          => true,
    						'sanitize_callback' => array( $this, 'check_reassign' ),
    					),
    				),
    			),
    			'allow_batch' => $this->allow_batch,
    			'schema'      => array( $this, 'get_public_item_schema' ),
    		)
    	);

    	register_rest_route(
    		$this->namespace,
    		'/' . $this->rest_base . '/me',
    		array(
    			array(
    				'methods'             => WP_REST_Server::READABLE,
    				'permission_callback' => '__return_true',
    				'callback'            => array( $this, 'get_current_item' ),
    				'args'                => array(
    					'context' => $this->get_context_param( array( 'default' => 'view' ) ),
    				),
    			),
    			array(
    				'methods'             => WP_REST_Server::EDITABLE,
    				'callback'            => array( $this, 'update_current_item' ),
    				'permission_callback' => array( $this, 'update_current_item_permissions_check' ),
    				'args'                => $this->get_endpoint_args_for_item_schema( WP_REST_Server::EDITABLE ),
    			),
    			array(
    				'methods'             => WP_REST_Server::DELETABLE,
    				'callback'            => array( $this, 'delete_current_item' ),
    				'permission_callback' => array( $this, 'delete_current_item_permissions_check' ),
    				'args'                => array(
    					'force'    => array(
    						'type'        => 'boolean',
    						'default'     => false,
    						'description' => __( 'Required to be true, as users do not support trashing.' ),
    					),
    					'reassign' => array(
    						'type'              => 'integer',
    						'description'       => __( 'Reassign the deleted user\'s posts and links to this user ID.' ),
    						'required'          => true,
    						'sanitize_callback' => array( $this, 'check_reassign' ),
    					),
    				),
    			),
    			'schema' => array( $this, 'get_public_item_schema' ),
    		)
    	);
    }
    ```

[View all references](https://developer.wordpress.org/reference/files/wp-includes/rest-api/endpoints/class-wp-rest-users-controller.php/)
[View on Trac](https://core.trac.wordpress.org/browser/tags/6.9.4/src/wp-includes/rest-api/endpoints/class-wp-rest-users-controller.php#L54)
[View on GitHub](https://github.com/WordPress/wordpress-develop/blob/6.9.4/src/wp-includes/rest-api/endpoints/class-wp-rest-users-controller.php#L54-L163)

## 󠀁[Related](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#related)󠁿

| Uses | Description | 
| [WP_REST_Users_Controller::get_collection_params()](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/get_collection_params/)`wp-includes/rest-api/endpoints/class-wp-rest-users-controller.php` |

Retrieves the query params for collections.

  | 
| [register_rest_route()](https://developer.wordpress.org/reference/functions/register_rest_route/)`wp-includes/rest-api.php` |

Registers a REST API route.

  | 
| [__()](https://developer.wordpress.org/reference/functions/__/)`wp-includes/l10n.php` |

Retrieves the translation of $text.

  |

[Show 1 more](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#)
[Show less](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#)

## 󠀁[Changelog](https://developer.wordpress.org/reference/classes/wp_rest_users_controller/register_routes/?output_format=md#changelog)󠁿

| Version | Description | 
| [4.7.0](https://developer.wordpress.org/reference/since/4.7.0/) | Introduced. |

## User Contributed Notes

You must [log in](https://login.wordpress.org/?redirect_to=https%3A%2F%2Fdeveloper.wordpress.org%2Freference%2Fclasses%2Fwp_rest_users_controller%2Fregister_routes%2F)
before being able to contribute a note or feedback.